/********************************** (C) COPYRIGHT *******************************
 * File Name          : usb_desc.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2023/04/06
 * Description        : usb device descriptor,configuration descriptor,
 *                      string descriptors and other descriptors.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

#include "usb_desc.h"

/* Device Descriptor */
const uint8_t  MyDevDescr[] =
{
    0x12,           //豸ȣ18ֽ
    0x01,           //ͣ0x01Ϊ豸
    0x10,0x01,      //豸ʹUSB汾Э飬ΪС˽ṹԵֽǰUSB1.1汾Ϊ0x10,0x01USB2.0Ϊ0x00,0x02
    0xFF,           //룬ԶΪ0xffCDCΪ0x02CDC豸ָ豸ͣ0x02üӿڣᱻϵͳΪһUSB豸Ӷ豸
    //ָ豸Ϊͨ豸ʹõЭ鶼ָΪ0.
    0x00,           //룬bDeviceClassΪ0ʱbDeviceSubClassҲΪ0
    0x00,           //豸ʹõЭ飬ЭUSBЭ涨ֶΪ0ʱʾ豸ʹЭ顣
    DEF_USBD_UEP0_SIZE,     //˵0ȡֵ8163264˴Ϊ8ֽ
    (uint8_t)DEF_USB_VID, (uint8_t)(DEF_USB_VID >> 8),      //ID
    (uint8_t)DEF_USB_PID, (uint8_t)(DEF_USB_PID >> 8),      //Ʒ豸ID
    0x64,0x02,      //豸汾
    0x00,           //̵ֵֵַΪ0ʱʾûгַ
    0x02,           //ƷֵֵַΪ0ʱʾûвƷַ
    0x00,           //豸кֵֵַΪ0ʱʾûкַ
    0x01,           //ܵͨΪ1
};

/* Configuration Descriptor */
const uint8_t  MyCfgDescr[] =
{
    //1ӿڣ
    0x09,          //ȣ׼USBΪ9ֽ
    0x02,          //ͣΪ0x02
    0x27,0x00,     //ܳȣ39ֽ
    0x01,          //ֵ֧Ľӿ1ӿ
    0x01,          //ʾõֵ
    0x00,          //õֵַ0x00ʾûַ
    0x80,          //豸һЩԣ繩緽ʽͻѵ
    0x31,          //豸Ҫ߻ȡ0x31ʾ98ma

    //Ϊӿӿܵأ븽һ
    0x09,          //ӿȣ׼USBӿΪ9ֽ
    0x04,          //ͣӿΪ0x04
    0x00,          //ýӿڵıţ0ʼ˴Ϊ0x00
    0x00,          //ýӿڵıñ,ͨΪ0
    0x03,          //ýӿʹõĶ˵0x03ʾʹ3˵㡣ֶΪ0ʾûз0˵㣬ֻʹĬϵĿƶ˵㡣CDCӿֻʹһж˵
    0xFF,          //ýӿʹõ࣬0xFFΪԶ
    0x01,          //ýӿʹõ
    0x02,          //ýӿʹõЭ
    0x00,          //ýӿڵֵַ0x00ʾûַ

    //ϴ˵㣬˵2
    0x07,          //˵ȣ7ֽ
    0x05,          //ͣ˵Ϊ0x05
    0x82,          //ö˵ĵַ0x82ʾ˵2Ϊ
    0x02,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
    (uint8_t)DEF_USBD_ENDP2_SIZE, (uint8_t)( DEF_USBD_ENDP2_SIZE >> 8 ),     //ö˵ֵ֧ȣ64ֽ
    0x00,          //˵Ĳѯʱ䣬˵Ч

    //´˵ ˵2
    0x07,          //˵ȣ7ֽ
    0x05,          //ͣ˵Ϊ0x05
    0x02,          //ö˵ĵַ0x02ʾ˵2Ϊ
    0x02,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
    (uint8_t)DEF_USBD_ENDP2_SIZE, (uint8_t)( DEF_USBD_ENDP2_SIZE >> 8 ),     //ö˵ֵ֧ȣ64ֽ
    0x00,          //˵Ĳѯʱ䣬˵Ч

    //жϴ˵㣬˵1
    0x07,          //˵ȣ7ֽ
    0x05,          //ͣ˵Ϊ0x05
    0x81,          //ö˵ĵַ0x81ʾ˵1Ϊ
    0x03,          //ö˵ԡλD1-0ʾö˵Ĵͣ0Ϊƴ䣬1Ϊʱ䣬2Ϊ䣬3Ϊжϴ
    (uint8_t)DEF_USBD_ENDP1_SIZE, (uint8_t)( DEF_USBD_ENDP1_SIZE >> 8 ),     //ö˵ֵ֧ȣ8ֽ
    0x01,          //˵Ĳѯʱ
};

/* Language Descriptor */
const uint8_t  MyLangDescr[] =
{
    0x04, 0x03, 0x09, 0x04
};

/* Manufacturer Descriptor */
const uint8_t  MyManuInfo[] =
{
    0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0
};

/* Product Information */
const uint8_t  MyProdInfo[] =
{
    0x16, 0x03, 'U', 0x00, 'S', 0x00, 'B', 0x00, ' ', 0x00, 'S', 0x00, 'e', 0x00,
                    'r', 0x00, 'i', 0x00, 'a', 0x00, 'l', 0x00
};

/* Serial Number Information */
const uint8_t  MySerNumInfo[] =
{
    0x16, 0x03, '0', 0, '1', 0, '2', 0, '3', 0, '4', 0, '5', 0
              , '6', 0, '7', 0, '8', 0, '9', 0
};

